<table class="table">
  <tr class="head-column">
    <th
      class="column"
      *ngFor="let head of columns"
      [ngClass]="{
        centered: head.isCentered,
        no_padding: head.key === 'nextButton'
      }"
    >
      {{ head.title }}
    </th>
  </tr>
  <ng-container></ng-container>
  <ng-container></ng-container>

  <tr class="row" *ngFor="let row of rows">
    <!-- <ng-container *ngIf="!row.list; else nestedRow"> -->

    <ng-container *ngIf="!row.list">
      <td
        class="row-column"
        [ngClass]="{
          centered: head.isCentered || head.key === 'nextButton',
          no_padding: head.isCentered || head.key === 'nextButton'
        }"
        [ngStyle]="{
          width:
            head.key === 'nextButton'
              ? '3%'
              : 'calc(100%/' + columns.length + ')'
        }"
        *ngFor="let head of columns"
      >
        <ng-container *ngFor="let item of objectKeys(row)">
          <ng-container #simpleRow *ngIf="head.key === item && !row.list">
            <ng-container [ngSwitch]="row[item].type">
              <ng-container *ngSwitchCase="'link'">
                <a
                  class="table-link"
                  routerLink="{{ row[item].link }}"
                  routerLinkActive="active"
                  [ngStyle]="{ 'max-width': row[item].maxWidth + 'px' }"
                  [ngClass]="{
                    before: row[item].symbol === 'before',
                    after: row[item].symbol === 'after'
                  }"
                  href="#"
                  >{{ row[item].value }}</a
                >
              </ng-container>
              <ng-container *ngSwitchCase="'nextButton'">
                >
              </ng-container>
              <ng-container *ngSwitchCase="'size'">
                <app-size [size]="row[item].value"></app-size>
              </ng-container>
              <ng-container *ngSwitchCase="'status-no-outline'">
                <app-status-no-outline
                  [status]="row[item].value"
                ></app-status-no-outline>
              </ng-container>
              <ng-container *ngSwitchCase="'status'">
                <app-status [status]="row[item].value"></app-status>
              </ng-container>
              <ng-container *ngSwitchCase="'purchasedSize'">
                <app-purchased-size
                  [size]="row[item].value"
                ></app-purchased-size>
              </ng-container>
              <ng-container *ngSwitchDefault>
                {{ row[item].value || row[item] }}
                <span *ngIf="!row[item]" [ngClass]="{ gray: !row[item] }">
                  Undefined
                </span>
              </ng-container>
            </ng-container>
          </ng-container>
        </ng-container>
      </td>
    </ng-container>

    <ng-container *ngIf="row.list">
      <td
        class="row-column"
        [ngClass]="{
          centered: head.isCentered || head.key === 'nextButton',
          no_padding: head.isCentered || head.key === 'nextButton'
        }"
        [ngStyle]="{
          'background-color': collapseOppened.has(row.orderId.value)
            ? '#F8F9FC'
            : 'white',
          'vertical-align': collapseOppened.has(row.orderId.value)
            ? 'top'
            : 'inherit',
          width:
            head.key === 'nextButton'
              ? '3%'
              : 'calc(100%/' + columns.length + ')'
        }"
        *ngFor="let head of columns"
      >
        <a
          *ngIf="head.key === 'orderId'"
          class="table-link"
          routerLink="{{ row.orderId.link }}"
          [ngStyle]="{ 'max-width': row.orderId.maxWidth + 'px' }"
          [ngClass]="{
            before: row.orderId.symbol === 'before',
            after: row.orderId.symbol === 'after'
          }"
          href="#"
          >{{ row.orderId.value }}</a
        >

        <ng-container class="row-column" *ngIf="head.key === 'date'">{{
          row.date
        }}</ng-container>

        <ng-container *ngIf="!['orderId', 'date'].includes(head.key)">
          <ng-container *ngFor="let item of objectKeys(row.list[0])">
            <table *ngIf="head.key === item" class="table">
              <ng-container *ngFor="let listRow of row.list; let i = index">
                <tr
                  *ngIf="
                    i === 0 ||
                    (i !== 0 && collapseOppened.has(row.orderId.value))
                  "
                >
                  <td
                    [ngClass]="{ 'nested-column': i !== 0 }"
                    [ngSwitch]="listRow[item].type"
                  >
                    <ng-container *ngSwitchCase="'link'">
                      <ng-container
                        *ngIf="!collapseOppened.has(row.orderId.value)"
                      >
                      <span style="color:#9EA1AE"> Multiple products</span>
                      </ng-container>
                      <ng-container
                        *ngIf="collapseOppened.has(row.orderId.value)"
                      >
                        <a
                          class="table-link"
                          routerLink="{{ listRow[item].link }}"
                          routerLinkActive="active"
                          [ngStyle]="{
                            'max-width': listRow[item].maxWidth + 'px'
                          }"
                          [ngClass]="{
                            before: listRow[item].symbol === 'before',
                            after: listRow[item].symbol === 'after'
                          }"
                          href="#"
                        >
                          {{ listRow[item].value || listRow[item] }}
                        </a>
                      </ng-container>
                    </ng-container>
                    <ng-container *ngSwitchCase="'size'">
                      <ng-container
                        *ngIf="!collapseOppened.has(row.orderId.value)"
                      >
                        <app-purchased-size
                          [size]="listRow[item].value"
                        ></app-purchased-size>
                      </ng-container>
                      <ng-container
                        *ngIf="collapseOppened.has(row.orderId.value)"
                      >
                        <app-size [size]="listRow[item].value"></app-size>
                      </ng-container>
                    </ng-container>
                    <ng-container *ngSwitchCase="'status-no-outline'">
                      <app-status-no-outline
                        [status]="listRow[item].value"
                      ></app-status-no-outline>
                    </ng-container>
                    <ng-container *ngSwitchCase="'status'">
                      <app-status [status]="listRow[item].value"></app-status>
                    </ng-container>
                    <ng-container *ngSwitchCase="'purchasedSize'">
                      <app-purchased-size
                        [size]="listRow[item].value"
                      ></app-purchased-size>
                    </ng-container>
                    <ng-container *ngSwitchDefault>
                      <ng-container
                        *ngIf="!collapseOppened.has(row.orderId.value)"
                      >
                        {{ listRow[item].value || listRow[item] }} 
                        <span style="color:#9EA1AE"> + {{ row.list.length - 1 }} more</span>
                      </ng-container>
                      <ng-container
                        *ngIf="collapseOppened.has(row.orderId.value)"
                      >
                        {{ listRow[item].value || listRow[item] }}
                      </ng-container>
                      <span
                        *ngIf="!listRow[item]"
                        [ngClass]="{ gray: !listRow[item] }"
                      >
                        Undefined
                      </span>
                    </ng-container>
                  </td>
                </tr>
              </ng-container>
            </table>
          </ng-container>
        </ng-container>

        <button
          *ngIf="head.key === 'nextButton'"
          (click)="toggleCollapse(row.orderId.value)"
          class="next-button"
          [ngClass]="{ open: collapseOppened.has(row.orderId.value) }"
        >
          >
        </button>
      </td>
    </ng-container>

    <!-- </ng-container> -->

    <!-- <ng-container #nestedRow>
        <td
        class="row-column"
        [ngClass]="{
          centered: head.isCentered || head.key === 'nextButton',
          no_padding: head.isCentered || head.key === 'nextButton'
        }"
        [ngStyle]="{
          width:
            head.key === 'nextButton'
              ? '3%'
              : 'calc(100%/' + columns.length + ')'
        }"
        *ngFor="let head of columns"
      >
        <ng-container *ngFor="let item of objectKeys(row)">
          <ng-container *ngIf="item === 'list'">

          </ng-container>
          <ng-container *ngIf="head.key === item">
            
          </ng-container>
        </ng-container>
      </td>
    </ng-container> -->
  </tr>
</table>
